<script setup lang="ts">
import type { Phenotype } from "~/utils/types/phenotype";
import { OTHER_DSRNA } from "~/utils/types/phenotype";
import { iBeetleDsRNAsKey } from "~/utils/injectionKeys";

const iBeetleDsRNAs = inject(iBeetleDsRNAsKey);
if (iBeetleDsRNAs === undefined) {
  throw new Error("iBeetleDsRNAs must be provided by a parent component");
}

type DsRNA = Phenotype["dsRNA"];

const props = defineProps<{ modelValue: DsRNA }>();
const emit = defineEmits<{
  (e: "update:modelValue", v: DsRNA): void;
}>();

const dsRNA = computed(() => props.modelValue);
const dsRNASequenceLookup = computed(() => {
  const lookup: Record<string, string> = {
    OTHER_DSRNA: "",
  };
  for (const dsRNA of iBeetleDsRNAs) {
    lookup[dsRNA.id] = dsRNA.seq;
  }
  return lookup;
});

const uploadedFiles = ref<File[]>();
watch(uploadedFiles, (newFiles) => {
  if (newFiles && newFiles.length > 0) {
    const newFile = newFiles[0];
    const reader = new FileReader();
    reader.onload = (e) => {
      emit("update:modelValue", {
        name: OTHER_DSRNA,
        sequence: e.target?.result?.toString() || "",
      });
    };
    reader.readAsText(newFile);
  } else {
    emit("update:modelValue", { name: OTHER_DSRNA, sequence: "" });
  }
});

const addDropFile = (e: DragEvent) => {
  uploadedFiles.value = [...(e.dataTransfer?.files || [])];
};
</script>

<template>
  <v-radio-group
    :model-value="dsRNA.name"
    @update:modelValue="
      (name: string | null) =>
        emit('update:modelValue', {
          name: name || undefined,
          sequence: (name && dsRNASequenceLookup[name]) || undefined,
        })
    "
  >
    <v-radio
      v-for="{ id } in iBeetleDsRNAs"
      :key="id"
      :value="id"
      :label="id"
      color="primary"
    />
    <v-radio :value="OTHER_DSRNA" label="New sequence" color="primary" />
  </v-radio-group>
  <v-expand-transition>
    <div v-if="dsRNA.name === OTHER_DSRNA" class="pb-8 pl-10">
      <div class="text-subtitle-2 font-italic pa-0">
        You can either upload the fasta file for your dsRNA ...
      </div>
      <div @drop.prevent="addDropFile" @dragover.prevent>
        <v-file-input
          v-model="uploadedFiles"
          single-line
          label="Upload fasta"
        />
      </div>
      <div class="text-subtitle-2 font-italic pa-0">
        ... or paste the sequence below
      </div>
      <InputLabel text="Sequence of the new dsRNA:" />
      <v-textarea
        :model-value="dsRNA.sequence"
        hint="Please provide the target sequence because this may influence the results."
        persistent-hint
        @update:modelValue="
          (sequence: string) =>
            emit('update:modelValue', { name: OTHER_DSRNA, sequence })
        "
      />
    </div>
  </v-expand-transition>
</template>
